package com.shadeslider.base 
{
    import com.shadeslider.project.controllers.*;
    
    public class AbstractController extends Object
    {
        public function AbstractController(arg1:com.shadeslider.base.AbstractModel, arg2:com.shadeslider.base.ComponentView, arg3:Object, arg4:com.shadeslider.project.controllers.MainController=null)
        {
            super();
            this.model = arg1;
            this.view = arg2;
            this.config = arg3;
            this.mainController = arg4;
            this._children = new Object();
            this.initialize();
            this.addChildren();
            this.addViewEventListeners();
            return;
        }

        protected function addChildren():void
        {
            return;
        }

        public function getChild(arg1:String):com.shadeslider.base.AbstractController
        {
            return this._children[arg1];
        }

        protected function addViewEventListeners():void
        {
            return;
        }

        protected function initialize():void
        {
            return;
        }

        public function addChild(arg1:String, arg2:com.shadeslider.base.AbstractController):void
        {
            this._children[arg1] = arg2;
            return;
        }

        public function get children():Object
        {
            return this._children;
        }

        protected var config:Object;

        protected var view:com.shadeslider.base.ComponentView;

        protected var model:*;

        protected var mainController:com.shadeslider.project.controllers.MainController;

        protected var _children:Object;
    }
}
