package com.shadeslider.utils 
{
    public class Easing extends Object
    {
        public function Easing()
        {
            super();
            return;
        }

        public static function easeInOutBounce(arg1:*, arg2:*, arg3:*, arg4:*):*
        {
            if (arg1 < arg4 / 2)
            {
                return easeInBounce(arg1 * 2, 0, arg3, arg4) * 0.5 + arg2;
            }
            return easeOutBounce(arg1 * 2 - arg4, 0, arg3, arg4) * 0.5 + arg3 * 0.5 + arg2;
        }

        public static function easeInOutQuart(arg1:*, arg2:*, arg3:*, arg4:*):*
        {
            var loc1:*;
            arg1 = loc1 = arg1 / (arg4 / 2);
            if (loc1 < 1)
            {
                return arg3 / 2 * arg1 * arg1 * arg1 * arg1 + arg2;
            }
            arg1 = loc1 = arg1 - 2;
            return (-arg3) / 2 * (loc1 * arg1 * arg1 * arg1 - 2) + arg2;
        }

        public static function easeInExpo(arg1:*, arg2:*, arg3:*, arg4:*):*
        {
            return arg1 != 0 ? arg3 * Math.pow(2, 10 * (arg1 / arg4 - 1)) + arg2 : arg2;
        }

        public static function easeOutBack(arg1:*, arg2:*, arg3:*, arg4:*, arg5:*):*
        {
            if (arg5 == undefined)
            {
                arg5 = 1.70158;
            }
            var loc1:*;
            arg1 = loc1 = (arg1 / arg4 - 1);
            return arg3 * (loc1 * arg1 * ((arg5 + 1) * arg1 + arg5) + 1) + arg2;
        }

        public static function easeOutBounce(arg1:*, arg2:*, arg3:*, arg4:*):*
        {
            var loc1:*;
            arg1 = loc1 = arg1 / arg4;
            if (loc1 < 1 / 2.75)
            {
                return arg3 * 7.5625 * arg1 * arg1 + arg2;
            }
            if (arg1 < 2 / 2.75)
            {
                arg1 = loc1 = arg1 - 1.5 / 2.75;
                return arg3 * (7.5625 * loc1 * arg1 + 0.75) + arg2;
            }
            if (arg1 < 2.5 / 2.75)
            {
                arg1 = loc1 = arg1 - 2.25 / 2.75;
                return arg3 * (7.5625 * loc1 * arg1 + 0.9375) + arg2;
            }
            arg1 = loc1 = arg1 - 2.625 / 2.75;
            return arg3 * (7.5625 * loc1 * arg1 + 0.984375) + arg2;
        }

        public static function easeInOutBack(arg1:*, arg2:*, arg3:*, arg4:*, arg5:*):*
        {
            if (arg5 == undefined)
            {
                arg5 = 1.70158;
            }
            var loc1:*;
            arg1 = loc1 = arg1 / (arg4 / 2);
            if (loc1 < 1)
            {
                arg5 = loc1 = arg5 * 1.525;
                return arg3 / 2 * arg1 * arg1 * ((loc1 + 1) * arg1 - arg5) + arg2;
            }
            arg1 = loc1 = arg1 - 2;
            arg5 = loc1 = arg5 * 1.525;
            return arg3 / 2 * (loc1 * arg1 * ((loc1 + 1) * arg1 + arg5) + 2) + arg2;
        }

        public static function easeInQuart(arg1:*, arg2:*, arg3:*, arg4:*):*
        {
            var loc1:*;
            arg1 = loc1 = arg1 / arg4;
            return arg3 * loc1 * arg1 * arg1 * arg1 + arg2;
        }

        public static function easeInOutExpo(arg1:*, arg2:*, arg3:*, arg4:*):*
        {
            if (arg1 == 0)
            {
                return arg2;
            }
            if (arg1 == arg4)
            {
                return arg2 + arg3;
            }
            var loc1:*;
            arg1 = loc1 = arg1 / (arg4 / 2);
            if (loc1 < 1)
            {
                return arg3 / 2 * Math.pow(2, 10 * (arg1 - 1)) + arg2;
            }
            return arg3 / 2 * (-Math.pow(2, -10 * --arg1) + 2) + arg2;
        }

        public static function easeOutExpo(arg1:*, arg2:*, arg3:*, arg4:*):*
        {
            return arg1 != arg4 ? arg3 * (-Math.pow(2, -10 * arg1 / arg4) + 1) + arg2 : arg2 + arg3;
        }

        public static function flat(arg1:*, arg2:*, arg3:*, arg4:*):*
        {
            return arg3 * arg1 / arg4 + arg2;
        }

        public static function easeInBack(arg1:*, arg2:*, arg3:*, arg4:*, arg5:*):*
        {
            if (arg5 == undefined)
            {
                arg5 = 1.70158;
            }
            var loc1:*;
            arg1 = loc1 = arg1 / arg4;
            return arg3 * loc1 * arg1 * ((arg5 + 1) * arg1 - arg5) + arg2;
        }

        public static function easeInBounce(arg1:*, arg2:*, arg3:*, arg4:*):*
        {
            return arg3 - easeOutBounce(arg4 - arg1, 0, arg3, arg4) + arg2;
        }

        public static function easeOutQuart(arg1:*, arg2:*, arg3:*, arg4:*):*
        {
            var loc1:*;
            arg1 = loc1 = (arg1 / arg4 - 1);
            return (-arg3) * (loc1 * arg1 * arg1 * arg1 - 1) + arg2;
        }
    }
}
